package drawing;


import java.awt.*;
import java.awt.geom.*;

public class LinearThemeRiverDrawer extends ThemeRiverDrawer {



  public LinearThemeRiverDrawer(Point[][] controlpoints, int width, int height, ColorList cl) {
    super(controlpoints, width, height, cl);
  }



  public void draw(Graphics2D g2d) {

    if (controlpoints != null) {

      //GeneralPath, in welche die Linienzge geschrieben werden
      GeneralPath[] regions = new GeneralPath[controlpoints[0].length];

      //Initialisierung
      for (int i = 0; i < controlpoints[0].length; i++) {
        regions[i] = new GeneralPath();
      }

      //Erstellen der linearen Pfade
      for (int i = 0; i < controlpoints.length-1; i++) {
        for (int j = 0; j < controlpoints[0].length; j++) {
          g2d.setColor(cl.getColor(j));

          Point p1 = controlpoints[i][j];
          Point p2 = controlpoints[i+1][j];


          Line2D.Double currline = new Line2D.Double(p1, p2);

          //g2d.draw(currcurve);
          regions[j].append(currline, true);

        }
      }

      //Zeichnen der Flchen
      for (int i = 0; i < controlpoints[0].length-1; i++) {
        //GeneralPath dessen obere Grenze dem oberen Linienzug entspricht
        GeneralPath currpath = new GeneralPath();
        currpath.append(regions[i], false);

        //Erweitern auf die unteren Ecken des Bildes
        currpath.lineTo((float)width,(float)height);
        currpath.lineTo((float)0,(float)height);
        currpath.closePath();



        //GeneralPath dessen untere Grenze dem unteren Linienzug entspricht
        GeneralPath currpath2 = new GeneralPath();
        currpath2.append(regions[i+1], false);

        currpath2.lineTo((float)width,(float)0);
        currpath2.lineTo((float)0,(float)0);
        currpath2.closePath();

        //Erstellen einer Area fr die MagicLens
        Area lens = new Area(new Rectangle(lenscenterx-lenswidth/2, MARGIN/2, lenswidth, height-MARGIN));

        //Verunden der beiden GeneralPaths mit Hilfe der Area-Klasse
        Area upper = new Area(currpath);
        upper.intersect(new Area(currpath2));
        upper.subtract(lens);

        g2d.setColor(cl.getColor(i));
        g2d.fill(upper);
      }

      //Seitenrnder gerade schneiden
      g2d.setColor(Color.WHITE);
      //lsche linken Seitenrand
      g2d.fillRect(0, controlpoints[0][0].y, controlpoints[0][0].x-1,
      controlpoints[0][controlpoints[0].length-1].y - controlpoints[0][0].y);

      //lsche rechten Seitenrand
      g2d.fillRect(controlpoints[controlpoints.length-1][0].x+1, controlpoints[controlpoints.length-1][0].y,
      width-(controlpoints[controlpoints.length-1][0].x+1),
      controlpoints[controlpoints.length-1][controlpoints[0].length-1].y - controlpoints[controlpoints.length-1][0].y);




    }

  }



}